import { Component } from '@angular/core';
import * as Diagramming from '@mindfusion/diagramming';

@Component({
  selector: 'min-app',
  templateUrl: './min-app.html'
})
export class MinApp{
    
  diagram: Diagramming.Diagram;
  behavior: Diagramming.Behavior;
  nodes: number;
  links: number;

  constructor(){
    this.behavior = Diagramming.Behavior.LinkShapes;
    this.diagram = new Diagramming.Diagram();
    this.diagram.shadowsStyle = Diagramming.ShadowsStyle.None;

    var shapeNode = this.diagram.factory.createShapeNode(20, 10, 50, 50);
    var tableNode = this.diagram.factory.createTableNode(100, 10, 50, 50);
    this.diagram.factory.createDiagramLink(shapeNode, tableNode);

    this.nodes = this.diagram.nodes.length;
    this.links = this.diagram.links.length;
  }


  onLinkCreated(event: any){
    this.links = this.diagram.links.length;
    var diagramLink = event.args;
    diagramLink.link.headShape = Diagramming.Shape.fromId("Arrow");
    diagramLink.link.headShapeSize = 5;
  }

  onLinkDeleted(event: any){
    this.links = this.diagram.links.length;
  }

  onNodeCreated(event: any) {
    var node = event.args.node;
    if (node instanceof Diagramming.TableNode) {
      node.text = "Table";
    }
    else if (node instanceof Diagramming.ContainerNode) {
      node.text = "Container";
      node.foldable = true;
    }
    this.nodes = this.diagram.nodes.length;
  }

  onNodeDeleted(event: any){
    this.nodes = this.diagram.nodes.length;
  }

  onBehaviorChange(e: any) {
    this.behavior = +e.target.value;
  }
}